
enum {
	Tstring,
	Tnumber,
	Ttrue,
	Tfalse,
	Tnull,
	Tmap,
	Tarray,
	Tempty		/* nothing parsed, but no errors, empty stream */
};

typedef struct Jmap Jmap;
typedef struct Jarray Jarray;
typedef struct Jvalue Jvalue;

struct Jarray {
	Jvalue **base;
	int alloc;
	int used;
};

struct Jmap {
	char *name;
	Jvalue *value;
	Jmap *next;
};

struct Jvalue {
	int type;
	union {
		char *str;
		double num;
		int bool;
		Jarray *array;
		Jmap *map;
	};
};


extern void json_dump(int fd, Jvalue *o);
extern Jvalue *json_parse(int fd, char *file);
extern char *json_strval(Jvalue *v, char *fmt, ...);
extern int json_numval(Jvalue *v, char *fmt, ...);
extern Jmap *Jmapfirst(Jvalue *v, char *fmt, ...);
extern void json_free(Jvalue *v);

#pragma lib "libjson.a"
